﻿using System;
using System.Configuration;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using CameraServer;

namespace SkyLordGateClient.BusinessLogic.VideoChat
{
    class VideoChatHelper
    {
        VideoService vsrv = null;   // Video service object from CameraServer module

        /// <summary>
        /// 
        /// </summary>
        public VideoChatHelper(string serverIP, int port) 
        {
            vsrv = new VideoService();
            vsrv.IPAddress = serverIP;
            vsrv.TCPPort = port;
            vsrv.OnStart();
        }

        /// <summary>
        /// Returns video devices (webcams).
        /// </summary>
        /// <returns></returns>
        public List<string> GetVideoDevices() 
        {
            return vsrv.GetVideoDevices();
        }

        /// <summary>
        /// Stops the video streaming service
        /// </summary>
        public void OnStop() 
        {
            vsrv.OnStop();
        }
    }
}
