﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Configuration;
using SkyLordGateClient.BusinessLogic;

namespace SkyLordGateClient.UserInterface
{
    /// <summary>
    /// 
    /// </summary>
    public partial class AuthorizationForm : Form
    {
        int userID = -1; // default -1, means user info is not present in DB

        public AuthorizationForm()
        {
            InitializeComponent();
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void okButton_Click(object sender, EventArgs e)
        {      
            //Perform DB check.
            CheckCredentials();
            
            /*if (userID == -1)
                MessageBox.Show("Authorization Failed. Please try again.","Error");             
            */

            this.DialogResult = DialogResult.OK;
            this.Close(); // temporary            
        }

        /// <summary>
        /// will perform username, password check
        /// </summary>
        /// <returns></returns>
        private void CheckCredentials() 
        {
            //check credentials from database and set the value of userID
            userID = int.Parse(ConfigurationManager.AppSettings["UserID"]); //temporary

            try
            {
                // Set userID in BusinessLogicManager Class
                BusinessLogicManager.Instance.SetUserID(userID);
                BusinessLogicManager.Instance.InitVideoService();
            }
            catch (Exception e) 
            {
                MessageBox.Show(e.Message);
                MessageBox.Show("Failed to establish connection with server. Please try again.");
                Application.Exit();
            }

        }        

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void cancelButton_Click(object sender, EventArgs e)
        {
            this.Close();
            Application.Exit();
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public int getUserID()
        {
            return userID;
        }
    }
}
