﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.Linq;
using System.Data.Linq.Mapping;
using System.Data.SqlClient;
using System.Configuration;

namespace SkyLordClientDbInterface
{
   
    
    public class ClientDbInterfaces : IClientDb
    {
        // Database object
        static string connString/* = ConfigurationManager.AppSettings["connectionStringSQL"]*/;
        /*// TO DO: modify connection string for local usage.
        string connString = @"Data Source=168.144.18.53\SQLEXPRESS;
            Initial Catalog=SkyLordClientDB;
            User ID=KhavkineVlad;Password=moskvich23";
        
        string connString = @"Data Source=SAMBA\SQLEXPRESS;
            Initial Catalog=SkyLordClientDB;Trusted_Connection=true";
        */
        DataContext db;

        public ClientDbInterfaces()
        {
            connString = ConfigurationManager.AppSettings["connectionStringSQL"];
            db = new DataContext(connString);
        }

        public ClientDbInterfaces(string connString)
        {
            db = new DataContext(connString);
        }

        public event EventHandler UserChanged;
        /// <summary>
        /// Fire event when User is changed.
        /// </summary>
        /// <param name="e">Event info</param>
        protected virtual void OnUserChanged(UserChangedEventArgs e)
        {
            if (UserChanged != null)
            {
                UserChanged(this, e);
            }
        }

        public event EventHandler TabChanged;
        /// <summary>
        /// Fire event when Tab is changed.
        /// </summary>
        /// <param name="e">Event info</param>
        protected virtual void OnTabChanged(TabChangedEventArgs e)
        {
            if (TabChanged != null)
            {
                TabChanged(this, e);
            }
        }

        public event EventHandler UserTabChanged;
        /// <summary>
        /// Fire event when UserTab is changed.
        /// </summary>
        /// <param name="e">Event info</param>
        protected virtual void OnUserTabChanged(UserTabChangedEventArgs e)
        {
            if (UserTabChanged != null)
            {
                UserTabChanged(this, e);
            }
        }

        #region Implement public interfaces

        
        /// <summary>
        /// Create table Users. Admin only usage during deployment.
        /// </summary>
        /// <return>Error Description</return>
        public string CreateTableUsers()
        {
            try
            {
                string strCreate = "IF EXISTS(SELECT name FROM sys.sysobjects " +
                      "WHERE  name = 'Users' AND type = 'U')" +
                      "DROP TABLE Users;" +
                      "CREATE TABLE Users (" + "UserID int, " + "IsAdmin bit, " +
                      "FamilyName varchar(50), " + "FirstName varchar(50), " + "IP varchar(15), " +
                      "Location varchar(50), " + "ShiftToServerHour INT, " + "Deleted BIT," +
                      "UserPwd varchar(50), " + "NickName varchar(50), " + "VideoCommunicationPort int)";
                db.ExecuteCommand(strCreate);
                return String.Empty;
            }
            catch (Exception ex)
            {
                return ex.Message;
            }
        }

        /// <summary>
        /// Create table Tabs. Admin only usage during deployment.
        /// </summary>
        /// <return>Error Description</return>
        public string CreateTableTabs()
        {
            try
            {
                string strCreate = "IF EXISTS(SELECT name FROM sys.sysobjects " +
                      "WHERE  name = 'Tabs' AND type = 'U')" +
                      "DROP TABLE Tabs;" +
                      "CREATE TABLE Tabs (TabID int, TabName varchar(50), Deleted BIT)";
                db.ExecuteCommand(strCreate);
                return String.Empty;
            }
            catch (Exception ex)
            {
                return ex.Message;
            }
        }

        /// <summary>
        /// Create table UserTab. Admin only usage during deployment.
        /// </summary>
        /// <return>Error Description</return>
        public string CreateTableUserTab()
        {
            try
            {
                string strCreate = "IF EXISTS(SELECT name FROM sys.sysobjects " +
                      "WHERE  name = 'UserTab' AND type = 'U')" +
                      "DROP TABLE UserTab;" +
                      "CREATE TABLE UserTab (UserID int, TabID int)";
                db.ExecuteCommand(strCreate);
                return String.Empty;
            }
            catch (Exception ex)
            {
                return ex.Message;
            }
        }

        /// <summary>
        /// Create table UserTabConnect. Admin only usage during deployment.
        /// </summary>
        /// <return>Error Description</return>
        public string CreateTableUserTabConnect()
        {
            try
            {
                string strCreate = "IF EXISTS(SELECT name FROM sys.sysobjects " +
                      "WHERE  name = 'UserTabConnect' AND type = 'U')" +
                      "DROP TABLE UserTabConnect;" +
                      "CREATE TABLE UserTabConnect (id INT IDENTITY(1,1) PRIMARY KEY, " +
                      "UserID int, TabID int, started DATETIME, terminated DATETIME)";
                db.ExecuteCommand(strCreate);
                return String.Empty;
            }
            catch (Exception ex)
            {
                return ex.Message;
            }
        }

        /// <summary>
        /// Create table UserConversation. Admin only usage during deployment.
        /// </summary>
        /// <return>Error Description</return>
        public string CreateTableUserConversation()
        {
            try
            {
                string strCreate = "IF EXISTS(SELECT name FROM sys.sysobjects " +
                      "WHERE  name = 'UserConversation' AND type = 'U')" +
                      "DROP TABLE UserConversation;" +
                      "CREATE TABLE UserConversation (id INT IDENTITY(1,1) PRIMARY KEY, " +
                      "UserID int, TabID int, DestinationID int, sent DATETIME, text varchar(MAX))";
                db.ExecuteCommand(strCreate);
                return String.Empty;
            }
            catch (Exception ex)
            {
                return ex.Message;
            }
        }

        /// <summary>
        /// AddUser to Users table. Admin only usage.
        /// </summary>
        /// <param name="user">user object</param>
        /// <param name="UserInfo">out UserInfo created</param>
        /// <return>Error Description</return>
        public string AddUser(UserInfo user, out UserInfo UserInfo)
        {
            try
            {
                // Get a typed table to run queries
                Table<UserInfo> UsersInfos = db.GetTable<UserInfo>();

                // Query for all Users to make Primary Key
                // This function is used by Admin only, so the overhead is not critical.
                var allUserInfos =
                    from Users in UsersInfos
                    select Users;
                int maxUserID = 0;
                if (allUserInfos.Count() > 0)
                {
                    foreach (UserInfo ui in allUserInfos)
                    {
                        if (ui.IsEqual(user))
                        {
                            UserInfo = null;
                            return "Duplicated User!";
                        }
                        if (ui.UserID > maxUserID)
                            maxUserID = ui.UserID;
                    }
                }
                UserInfo newUser = user;
                newUser.UserID = maxUserID + 1; // Primary Key

                UsersInfos.InsertOnSubmit(newUser);
                db.SubmitChanges();

                UserInfo = newUser;
                OnUserChanged(new UserChangedEventArgs(ChangeType.Added, newUser));
                return String.Empty;
            }
            catch (Exception ex)
            {
                UserInfo = null;
                return ex.Message;
            }
        }

        /// <summary>
        /// Change existing User in Users table. Admin only usage.
        /// </summary>
        /// <param name="user">user object</param>
        /// Fill all the fields including UserID. Fields not filled will be copied from Users table.
        /// <param name="UserInfo">out UserInfo changed</param>
        /// <return>Error Description</return>
        public string ChangeUser(UserInfo user, out UserInfo UserInfo)
        {
            try
            {
                // Get a typed table to run queries
                Table<UserInfo> UsersInfos = db.GetTable<UserInfo>();

                // Query for user to change
                // This function is used by Admin only, so the overhead is not critical.
                var allUsersFound =
                    from Users in UsersInfos
                    where Users.UserID == user.UserID
                    select Users;
                UserInfo = null;
                if (allUsersFound.Count() < 1)
                    return "User not found";
                
                var userFirst = allUsersFound.First();
                UserInfo = user;
                if (userFirst != user)
                {
                    allUsersFound.First().Assign(user);
                    db.SubmitChanges();
                    OnUserChanged(new UserChangedEventArgs(ChangeType.Modified, UserInfo));
                }
                return String.Empty;
            }
            catch (Exception ex)
            {
                UserInfo = null;
                return ex.Message;
            }
        }

        /// <summary>
        /// Get one User from Users table.
        /// </summary>
        /// <param name="UserID">UserID</param>
        /// <param name="Users">out Users</param>
        /// <return>Error Description</return>
        public string GetUser(int UserID, out UserInfo User)
        {
            try
            {
                // Get a typed table to run queries
                Table<UserInfo> UsersInfos = db.GetTable<UserInfo>();

                // Query for the Users
                var allUsers =
                    from Users in UsersInfos
                    where Users.UserID == UserID
                    select Users;
               
                if (allUsers.Count() < 1)
                {
                    User = null;
                    return "User not found";
                }
                var userFirst = allUsers.First();
                User = userFirst;
                return String.Empty;
            }
            catch (Exception ex)
            {
                User = null;
                return ex.Message;
            }
        }


        /// <summary>
        /// Remove all occurences of the specified User from Users table. Admin only usage.
        /// Use it to clean the table from garbage.
        /// </summary>
        /// <param name="FamilyName">FamilyName</param>
        /// <param name="FirstName">FirstName</param>
        /// <return>Error Description</return>
        public string RemoveUser(string FamilyName, string FirstName)
        {
            try
            {
                // Get a typed table to run queries
                Table<UserInfo> UsersInfos = db.GetTable<UserInfo>();

                // Query for all Users do be deleted
                var allUsersToDelete =
                    from Users in UsersInfos
                    where Users.FamilyName == FamilyName && Users.FirstName == FirstName
                    select Users;
                if (allUsersToDelete.Count() < 1)
                    return "Nothing found";

                foreach (var usr in allUsersToDelete)
                {
                    RemoveUser(usr.UserID);
                }
                return String.Empty;
            }
            catch (Exception ex)
            {
                return ex.Message;
            }
        }

        /// <summary>
        /// Remove the specified User from Users table. Admin only usage.
        /// Use it to clean the table from garbage.
        /// </summary>
        /// <param name="UserID">UserID</param>
        /// <return>Error Description</return>
        public string RemoveUser(int UserID)
        {
            try
            {
                // Get a typed table to run queries
                Table<UserInfo> UsersInfos = db.GetTable<UserInfo>();

                // Query for all Users do be deleted
                var allUsersToDelete =
                    from Users in UsersInfos
                    where Users.UserID == UserID
                    select Users;
                if (allUsersToDelete.Count() < 1)
                    return "User not Found";

                foreach (var usr in allUsersToDelete)
                {
                    // To Do: delete dependencies first
                    UsersInfos.DeleteOnSubmit(usr);
                    OnUserChanged(new UserChangedEventArgs(ChangeType.Removed, usr));
                }
                db.SubmitChanges();

                return String.Empty;
            }
            catch (Exception ex)
            {
                return ex.Message;
            }
        }



        /// <summary>
        /// Get list of all Users from Users table. Including Deleted as well.
        /// </summary>
        /// <param name="Users">out Users</param>
        /// <return>Error Description</return>
        public string GetAllUsers(out List<UserInfo> users)
        {
            try
            {
                
                // Get a typed table to run queries
                Table<UserInfo> UsersInfos = db.GetTable<UserInfo>();
              
                // Query for for all Users
                var allUsers =
                    from usr in UsersInfos
                    select usr;
                if (allUsers.Count() < 1)
                {
                    users = null;
                    return "Nothing found";
                }

                users = new List<UserInfo>();
                foreach(var usr1 in allUsers)
                {
                    UserInfo userFound = new UserInfo(usr1.UserID, usr1.IsAdmin, usr1.FamilyName, usr1.FirstName,
                        usr1.IP, usr1.Location, usr1.ShiftToServerHour, usr1.Deleted, usr1.UserPwd, usr1.NickName, 
                        usr1.VideoCommunicationPort);
                    users.Add(userFound);
                }
                return String.Empty;
            }
            catch (Exception ex)
            {
                users = null;
                return ex.Message;
            }
        }

        /// <summary>
        /// Get list of all Users (Not Deleted only) from Users table.
        /// </summary>
        /// <param name="Users">out Users</param>
        /// <return>Error Description</return>
        public string GetUsersNotDeleted(out List<UserInfo> users)
        {
            try
            {
                // Get a typed table to run queries
                Table<UserInfo> UsersInfos = db.GetTable<UserInfo>();

                // Query for for all Users
                var allUsers =
                    from usrs in UsersInfos
                    where usrs.Deleted == false
                    select usrs;

                if (allUsers.Count() < 1)
                {
                    users = null;
                    return "Nothing found";
                }

                users = new List<UserInfo>();
                foreach (var usr in allUsers)
                {
                    UserInfo userFound = new UserInfo(usr.UserID, usr.IsAdmin, usr.FamilyName, usr.FirstName,
                        usr.IP, usr.Location, usr.ShiftToServerHour, usr.Deleted, usr.UserPwd, usr.NickName,
                        usr.VideoCommunicationPort);
                    users.Add(userFound);
                }
                return String.Empty;
            }
            catch (Exception ex)
            {
                users = null;
                return ex.Message;
            }
        }
     
        /// <summary>
        /// Get list of all Users enabled to participate in the specified Tab.
        /// </summary>
        /// <param name="TabID">TabID</param>
        /// <param name="Users">out Users</param>
        /// <return>Error Description</return>
        public string GetUsersForTab(int TabID, out List<UserInfo> Users)
        {
            try
            {
                // Get a typed table to run queries
                Table<UserTabInfo> UserTabsInfos = db.GetTable<UserTabInfo>();

                // Query for for all Tabs
                var allUserTabs =
                    from usrTb in UserTabsInfos
                    where usrTb.TabID == TabID
                    select usrTb;

                Users = new List<UserInfo>();
                foreach (var userTab in allUserTabs)
                {
                    UserInfo userInfo = new UserInfo();
                    GetUser(userTab.UserID, out userInfo);
                    Users.Add(userInfo);
                }
                return String.Empty;
            }
            catch (Exception ex)
            {
                Users = null;
                return ex.Message;
            }
        }

        /// <summary>
        /// AddTab to Tabs table. Admin only usage.
        /// </summary>
        /// <param name="tab">tab object</param>
        /// <param name="TabInfo">out TabInfo created</param>
        /// <return>Error Description</return>
        public string AddTab(TabInfo tab, out TabInfo TabInfo)
        {
            try
            {
                // Get a typed table to run queries
                Table<TabInfo> TabsInfos = db.GetTable<TabInfo>();

                // Query for all Tabs to make Primary Key
                // This function is used by Admin only, so the overhead is not critical.
                var allTabInfos =
                    from Tabs in TabsInfos
                    select Tabs;
                int maxTabID = 0;
                if (allTabInfos.Count() > 0)
                {
                    foreach (TabInfo ui in allTabInfos)
                    {
                        if (ui.IsEqual(tab))
                        {
                            TabInfo = null;
                            return "Duplicated Tab!";
                        }
                        if (ui.TabID > maxTabID)
                            maxTabID = ui.TabID;
                    }
                }
                TabInfo newTab = tab;
                newTab.TabID = maxTabID + 1; // Primary Key

                TabsInfos.InsertOnSubmit(newTab);
                db.SubmitChanges();

                TabInfo = newTab;
                OnTabChanged(new TabChangedEventArgs(ChangeType.Added, newTab));
                return String.Empty;
            }
            catch (Exception ex)
            {
                TabInfo = new TabInfo();
                return ex.Message;
            }
        }

        /// <summary>
        /// Change existing Tab in Tabs table. Admin only usage.
        /// </summary>
        /// <param name="tab">tab object</param>
        /// Fill all the fields including TabID. Fields not filled will be copied from Tabs table.
        /// <param name="TabInfo">out TabInfo changed</param>
        /// <return>Error Description</return>
        public string ChangeTab(TabInfo tab, out TabInfo TabInfo)
        {
            try
            {
                // Get a typed table to run queries
                Table<TabInfo> TabsInfos = db.GetTable<TabInfo>();

                // Query for tab to change
                // This function is used by Admin only, so the overhead is not critical.
                var allTabsFound =
                    from tabs in TabsInfos
                    where tabs.TabID == tab.TabID
                    select tabs;

                if (allTabsFound.Count() < 1)
                {
                    TabInfo = null;
                    return "Tab not found";
                }
                var tabFirst = allTabsFound.First();

                TabInfo = tab;
                if (tabFirst != tab)
                {
                    allTabsFound.First().Assign(tab);
                    db.SubmitChanges();
                    OnTabChanged(new TabChangedEventArgs(ChangeType.Modified, TabInfo));
                }
                return String.Empty;
            }
            catch (Exception ex)
            {
                TabInfo = null;
                return ex.Message;
            }
        }

        /// <summary>
        /// Remove the specified Tab from Tabs table. Admin only usage.
        /// </summary>
        /// <param name="TabID">TabID</param>
        /// <return>Error Description</return>
        public string RemoveTab(int TabID)
        {
            try
            {
                // Get a typed table to run queries
                Table<TabInfo> TabsInfos = db.GetTable<TabInfo>();

                // Query for for all Tabs do be deleted
                var allTabsToDelete =
                    from Tabs in TabsInfos
                    where Tabs.TabID == TabID
                    select Tabs;
                if (allTabsToDelete.Count() < 1)
                {
                    return "Nothing found";
                }
                foreach (var tab in allTabsToDelete)
                {
                    // To Do: delete dependencies first
                    TabsInfos.DeleteOnSubmit(tab);
                    OnTabChanged(new TabChangedEventArgs(ChangeType.Removed, tab));
                }
                db.SubmitChanges();
               
                return String.Empty;
            }
            catch (Exception ex)
            {
                return ex.Message;
            }
        }

        /// <summary>
        /// Remove all occurences of the specified Tab from Tabs table. Admin only usage.
        /// </summary>
        /// <param name="TabName">TabName</param>
        /// <return>Error Description</return>
        public string RemoveTab(string TabName)
        {
            try
            {
                // Get a typed table to run queries
                Table<TabInfo> TabsInfos = db.GetTable<TabInfo>();

                // Query for for all Tabs do be deleted
                var allTabsToDelete =
                    from tabs in TabsInfos
                    where tabs.TabName == TabName
                    select tabs;
                if (allTabsToDelete.Count() < 1)
                {
                    return "Nothing found";
                }
                foreach (var tab in allTabsToDelete)
                {
                    RemoveTab(tab.TabID);
                }
                return String.Empty;
            }
            catch (Exception ex)
            {
                return ex.Message;
            }
        }

        /// <summary>
        /// Get list of all Tabs (including deleted) from Tabs table.
        /// </summary>
        /// <param name="Tabs">out Tabs</param>
        /// <return>Error Description</return>
        public string GetAllTabs(out List<TabInfo> AllTabs)
        {
            try
            {
                // Get a typed table to run queries
                Table<TabInfo> TabsInfos = db.GetTable<TabInfo>();

                // Query for for all Tabs
                var allTabs =
                    from tabs in TabsInfos
                    select tabs;
                AllTabs = new List<TabInfo>();
                if (allTabs.Count() < 1)
                {
                    return "Nothing found";
                }
                
                foreach (var tab in allTabs)
                {
                    AllTabs.Add(tab);
                }
                return String.Empty;
            }
            catch (Exception ex)
            {
                AllTabs = null;
                return ex.Message;
            }
        }

        /// <summary>
        /// Get list of all Tabs (excluding deleted) from Tabs table.
        /// </summary>
        /// <param name="Tabs">out Tabs</param>
        /// <return>Error Description</return>
        public string GetTabsNotDeleted(out List<TabInfo> AllTabs)
        {
            try
            {
                // Get a typed table to run queries
                Table<TabInfo> TabsInfos = db.GetTable<TabInfo>();

                // Query for for all Tabs
                var allTabs =
                    from tabs in TabsInfos
                    where tabs.Deleted == false
                    select tabs;
                AllTabs = new List<TabInfo>();
                if (allTabs.Count() < 1)
                {
                    return "Nothing found";
                }

                foreach (var tab in allTabs)
                {
                    AllTabs.Add(tab);
                }
                return String.Empty;
            }
            catch (Exception ex)
            {
                AllTabs = null;
                return ex.Message;
            }
        }

        /// <summary>
        /// Get one Tab from Tabs table.
        /// </summary>
        /// <param name="TabID">TabID</param>
        /// <param name="Tabs">out Tabs</param>
        /// <return>Error Description</return>
        public string GetTab(int TabID, out TabInfo Tab)
        {
            try
            {
                // Get a typed table to run queries
                Table<TabInfo> TabsInfos = db.GetTable<TabInfo>();

                // Query for the Tabs
                var allTabs =
                    from tabs in TabsInfos
                     where tabs.TabID == TabID
                     select tabs;
                Tab = null;
                if (allTabs.Count() < 1)
                {
                    return "Nothing found";
                }
                TabInfo tabFound = allTabs.First();
                Tab = tabFound;

                return String.Empty;
            }
            catch (Exception ex)
            {
                Tab = null;
                return ex.Message;
            }
        }


        /// <summary>
        /// Get list of all Tabs acceptable for the specified User.
        /// </summary>
        /// <param name="UserID">UserID</param>
        /// <param name="Tabs">out Tabs</param>
        /// <return>Error Description</return>
        public string GetTabsForUser(int UserID, out List<TabInfo> AllTabs)
        {
            try
            {
                // Get a typed table to run queries
                Table<UserTabInfo> UserTabsInfos = db.GetTable<UserTabInfo>();

                // Query for for all UserTabs
                var allUserTabs =
                    from userTabs in UserTabsInfos
                    where userTabs.UserID == UserID
                    select userTabs;
                AllTabs = new List<TabInfo>();
                if (allUserTabs.Count() < 1)
                {
                    return "Nothing found";
                }
                foreach (var userTab in allUserTabs)
                {
                    TabInfo tab = null;
                    GetTab(userTab.TabID, out tab);
                    AllTabs.Add(tab);
                }
                return String.Empty;
            }
            catch (Exception ex)
            {
                AllTabs = null;
                return ex.Message;
            }
        }

        /// <summary>
        /// Add the specified User to the specified Tabs. Admin only usage.
        /// The User will be able to participate only in the specified Tabs.
        /// </summary>
        /// <param name="UserID">UserID</param>
        /// <param name="TabIDs">List of TabIDs</param>
        /// <return>Error Description</return>
        public string AddUserToTabs(int UserID, List<int> TabIDs)
        {
            try
            {
                // Get a typed table to run queries
                Table<UserTabInfo> UserTabsInfos = db.GetTable<UserTabInfo>();
                UserTabInfo userTabInfo = null;
                var AllTabsForUser =
                    from userTabs in UserTabsInfos
                    where userTabs.UserID == UserID
                    select userTabs.TabID;

                foreach (int tabID in TabIDs)
                {
                    bool found = false;
                    foreach (int tabID1 in AllTabsForUser)
                    {
                        if (tabID1 == tabID)
                        {
                            // Already have this Tab
                            found = true;
                            break;
                        }
                    }
                    if (!found)
                    {
                        userTabInfo = new UserTabInfo(UserID, tabID);
                        UserTabsInfos.InsertOnSubmit(userTabInfo);
                        OnUserTabChanged(new UserTabChangedEventArgs(ChangeType.Added, userTabInfo));
                    }
                }
                db.SubmitChanges();
                return String.Empty;
            }
            catch (Exception ex)
            {
                return ex.Message;
            }
        }

        /// <summary>
        /// Remove the specified User from the specified Tabs. Admin only usage.
        /// The User will not be able to participate in the specified Tabs.
        /// </summary>
        /// <param name="UserID">UserID</param>
        /// <param name="TabIDs">List of TabIDs</param>
        /// <return>Error Description</return>
        public string RemoveUserFromTabs(int UserID, List<int> TabIDs)
        {
            try
            {
                // Get a typed table to run queries
                Table<UserTabInfo> UserTabsInfos = db.GetTable<UserTabInfo>();

                foreach (int tabID in TabIDs)
                {
                    UserTabInfo userTabInfo = new UserTabInfo(UserID, tabID);
                  
                    UserTabsInfos.DeleteOnSubmit(userTabInfo);
                    db.SubmitChanges();
                    OnUserTabChanged(new UserTabChangedEventArgs(ChangeType.Removed, userTabInfo));
                }
                return String.Empty;
            }
            catch (Exception ex)
            {
                return ex.Message;
            }
        }

        /// <summary>
        /// Make new record in UserTabConnect table.
        /// Set Start time for the specified User in the specified Tab.
        /// Set Connection (channel) between User and Tab.
        /// </summary>
        /// <param name="UserID">UserID</param>
        /// <param name="TabID">TabID</param>
        /// <return>Error Description</return>
        public string UserConnectStart(int UserID, int TabID)
        {
            try
            {
                // Get a typed table to run queries
                Table<UserTabConnectInfo> UserTabsConnectInfos = db.GetTable<UserTabConnectInfo>();
                
                DateTime date = db.ExecuteQuery<DateTime>("select getdate()").Single();
                string command = "insert into UserTabConnect(UserID, TabID, started, terminated) values(";
                    command += UserID.ToString() + ", " + TabID.ToString() + ", '" + date.ToString() + "', '";
                    command += new DateTime(1800, 1, 1).ToString() + "')";
                db.ExecuteCommand(command);
                return String.Empty;
            }
            catch (Exception ex)
            {
                return ex.Message;
            }
        }

        /// <summary>
        /// Make new record in UserTabConnect table.
        /// Set Start time for the specified User in the specified Tab.
        /// Set Connection (channel) between User and Tab.
        /// To be used by software running on Server computer to avoid concurrent 2 queries.
        /// </summary>
        /// <param name="UserID">UserID</param>
        /// <param name="TabID">TabID</param>
        /// <param name="now">now</param>
        /// <return>Error Description</return>
        public string UserConnectStart(int UserID, int TabID, DateTime now)
        {
            try
            {
                // Get a typed table to run queries
                Table<UserTabConnectInfo> UserTabsConnectInfos = db.GetTable<UserTabConnectInfo>();
                string command = "insert into UserTabConnect(UserID, TabID, started, terminated) values(";
                    command += UserID.ToString() + ", " + TabID.ToString() + ", '" + now.ToString() + "', '";
                    command += new DateTime(1800, 1, 1).ToString() + "')";
                db.ExecuteCommand(command);
                return String.Empty;
            }
            catch (Exception ex)
            {
                return ex.Message;
            }
        }

        /// <summary>
        /// Set End time for the specific UserTabConnect.
        /// Close Connection (channel) between User and Tab.
        /// </summary>
        /// <param name="userTabConnectID">userTabConnectID</param>
        /// <return>Error Description</return>
        public string UserConnectEnd(int userTabConnectID)
        {
            try
            {
                // Get a typed table to run queries
                Table<UserTabConnectInfo> UserTabsConnectInfos = db.GetTable<UserTabConnectInfo>();

                // Query for specific UserTabsConnectInfo
                var allUserTabConnectInfos =
                    from userTabConnect in UserTabsConnectInfos
                    where userTabConnect.id == userTabConnectID &&
                        userTabConnect.terminated < userTabConnect.started
                    select userTabConnect;
                if (allUserTabConnectInfos.Count() < 1)
                {
                    return "Nothing found";
                }
                DateTime date = db.ExecuteQuery<DateTime>("select getdate()").Single();
                allUserTabConnectInfos.Single().terminated = date;
                db.SubmitChanges();
                return String.Empty;
            }
            catch (Exception ex)
            {
                return ex.Message;
            }
        }

        /// <summary>
        /// Set End time for the specific UserTabConnect.
        /// Close Connection (channel) between User and Tab.
        /// To be used by software running on Server computer to avoid concurrent 2 queries.
        /// </summary>
        /// <param name="userTabConnectID">userTabConnectID</param>
        /// <param name="now">now</param>
        /// <return>Error Description</return>
        public string UserConnectEnd(int userTabConnectID, DateTime now)
        {
            try
            {
                // Get a typed table to run queries
                Table<UserTabConnectInfo> UserTabsConnectInfos = db.GetTable<UserTabConnectInfo>();

                // Query for specific UserTabsConnectInfo
                var allUserTabConnectInfos =
                    from userTabConnect in UserTabsConnectInfos
                    where userTabConnect.id == userTabConnectID &&
                        userTabConnect.terminated < userTabConnect.started
                    select userTabConnect;
                if (allUserTabConnectInfos.Count() < 1)
                {
                    return "Nothing found";
                }
                allUserTabConnectInfos.Single().terminated = now;
                db.SubmitChanges();
                return String.Empty;
            }
            catch (Exception ex)
            {
                return ex.Message;
            }
        }

        /// <summary>
        /// Set End time for the specific UserTabConnect.
        /// Close Connection (channel) between User and Tab.
        /// </summary>
        /// <param name="userID">userID</param>
        /// <param name="tabID">tabID</param>
        /// <return>Error Description</return>
        public string UserConnectEnd(int userID, int tabID)
        {
            try
            {
                // Get a typed table to run queries
                Table<UserTabConnectInfo> UserTabsConnectInfos = db.GetTable<UserTabConnectInfo>();

                // Query for specific UserTabsConnectInfo
                var allUserTabConnectInfos =
                    from userTabConnect in UserTabsConnectInfos
                    where userTabConnect.UserID == userID && userTabConnect.TabID == tabID &&
                        userTabConnect.terminated < userTabConnect.started
                    select userTabConnect;
                if (allUserTabConnectInfos.Count() < 1)
                {
                    return "Nothing found";
                }
                DateTime date = db.ExecuteQuery<DateTime>("select getdate()").Single();
                foreach (UserTabConnectInfo utci in allUserTabConnectInfos)
                    utci.terminated = date;
                db.SubmitChanges();
                return String.Empty;
            }
            catch (Exception ex)
            {
                return ex.Message;
            }
        }

        /// <summary>
        /// Set End time for the specific UserTabConnect.
        /// Close Connection (channel) between User and Tab.
        /// To be used by software running on Server computer to avoid concurrent 2 queries.
        /// </summary>
        /// <param name="userID">userID</param>
        /// <param name="tabID">tabID</param>
        /// <param name="now">now</param>
        /// <return>Error Description</return>
        public string UserConnectEnd(int userID, int tabID, DateTime now)
        {
            try
            {
                // Get a typed table to run queries
                Table<UserTabConnectInfo> UserTabsConnectInfos = db.GetTable<UserTabConnectInfo>();

                // Query for specific UserTabsConnectInfo
                var allUserTabConnectInfos =
                    from userTabConnect in UserTabsConnectInfos
                    where userTabConnect.UserID == userID && userTabConnect.TabID == tabID &&
                        userTabConnect.terminated < userTabConnect.started
                    select userTabConnect;
                if (allUserTabConnectInfos.Count() < 1)
                {
                    return "Nothing found";
                }
                foreach (UserTabConnectInfo utci in allUserTabConnectInfos)
                    utci.terminated = now;
                db.SubmitChanges();
                return String.Empty;
            }
            catch (Exception ex)
            {
                return ex.Message;
            }
        }

        /// <summary>
        /// Get Users connected to the specified Tab.
        /// </summary>
        /// <param name="TabID">TabID</param>
        /// <param name="out users">out users</param>
        /// <return>Error Description</return>
        public string GetUsersTabConnected(int TabID, out List<UserInfo> users)
        {
            try
            {
                // Get a typed table to run queries
                Table<UserTabConnectInfo> UserTabsConnectInfos = db.GetTable<UserTabConnectInfo>();

                // Query for all UserTabsConnectInfo
                var allUserTabConnectInfos =
                    from userTabConnect in UserTabsConnectInfos
                     where userTabConnect.TabID == TabID && userTabConnect.started < DateTime.Now 
                        && userTabConnect.started > userTabConnect.terminated
                     select userTabConnect;

                users = new List<UserInfo>();
                if (allUserTabConnectInfos.Count() < 1)
                {
                    return "Nothing found";
                }
                foreach(UserTabConnectInfo usrTabConn in allUserTabConnectInfos)
                {
                    UserInfo usr = null;
                    GetUser(usrTabConn.UserID, out usr);
                    users.Add(usr);
                }
                return String.Empty;
            }
            catch (Exception ex)
            {
                users = null;
                return ex.Message;
            }
        }

        /// <summary>
        /// Check if User is connected to the specified Tab.
        /// </summary>
        /// <param name="UserID">UserID</param>
        /// <param name="TabID">TabID</param>
        /// <param name="out result">out result</param>
        /// <return>Error Description</return>
        public string IsUserTabConnected(int UserID, int TabID, out bool result)
        {
            try
            {
                // Get a typed table to run queries
                Table<UserTabConnectInfo> UserTabsConnectInfos = db.GetTable<UserTabConnectInfo>();

                // Query for all UserTabsConnectInfo
                var allUserTabConnectInfos =
                    from userTabConnect in UserTabsConnectInfos
                    where userTabConnect.TabID == TabID && userTabConnect.UserID == UserID 
                        && userTabConnect.started < DateTime.Now
                       && userTabConnect.started > userTabConnect.terminated
                    select userTabConnect;

                result = true;
                if (allUserTabConnectInfos.Count() < 1)
                    result = false;
                
                return String.Empty;
            }
            catch (Exception ex)
            {
                result = false;
                return ex.Message;
            }
        }

        /// <summary>
        /// Get last UserTabConnectInfo connected.
        /// Close (make as disconnected) all orphan rows.
        /// Terminated when next row started.
        /// </summary>
        /// <param name="userID">userID</param>
        /// <param name="out result">out result</param>
        /// <return>Error Description</return>
        public string GetUserTabConnected(int userID, out UserTabConnectInfo result)
        {
            try
            {
                // Get a typed table to run queries
                Table<UserTabConnectInfo> UserTabsConnectInfos = db.GetTable<UserTabConnectInfo>();

                // Query for all UserTabsConnectInfo
                var allUserTabConnectInfos =
                    from userTabConnect in UserTabsConnectInfos
                    where userTabConnect.UserID == userID
                        && userTabConnect.started < DateTime.Now
                       && userTabConnect.started > userTabConnect.terminated
                    orderby userTabConnect.started descending

                    select userTabConnect;
                
                    result = null;

                if (allUserTabConnectInfos.Count() > 0)
                {
                    // Close (make as disconnected) all orphan rows
                    // Terminated when next row started
                    DateTime previous = DateTime.MinValue;
                    bool first = true;
                    foreach(UserTabConnectInfo userTab in allUserTabConnectInfos)
                    {
                        if (first)
                        {
                            result = userTab;
                            first = false;
                            previous = userTab.started;
                            continue;
                        }
                        userTab.terminated = previous;
                        previous = userTab.started;
                    }
                }
                
                db.SubmitChanges();
                return string.Empty;
            }
            catch (Exception ex)
            {
                result = null;
                return ex.Message;
            }
        }

        /// <summary>
        /// Make new record in UserConversation table. Save the User Conversation text input.
        /// </summary>
        /// <param name="UserID">UserID</param>
        /// <param name="TabID">TabID</param>
        /// <param name="DestinationID">DestinationID</param>
        /// <param name="Text">Text sent by User</param>
        /// <return>Error Description</return>
        public string UserConversation(int UserID, int TabID, int DestinationID, string Text)
        {
            try
            {
                DateTime date = db.ExecuteQuery<DateTime>("select getdate()").Single();
                
                // Get a typed table to run queries
                Table<UserConversationInfo> UserTabsConnectInfos = db.GetTable<UserConversationInfo>();
                
                UserConversationInfo newUserConversation = new UserConversationInfo(UserID, TabID, DestinationID, date, Text);
             
                UserTabsConnectInfos.InsertOnSubmit(newUserConversation);
                db.SubmitChanges();
                return String.Empty;
            }
            catch (Exception ex)
            {
                return ex.Message;
            }
        }

        /// <summary>
        /// Make new record in UserConversation table. Save the User Conversation text input.
        /// To be used by software running on Server computer to avoid exception concurrent queries.
        /// </summary>
        /// <param name="UserID">UserID</param>
        /// <param name="TabID">TabID</param>
        /// <param name="DestinationID">DestinationID</param>
        /// <param name="Text">Text sent by User</param>
        /// <param name="now">now</param>
        /// <return>Error Description</return>
        public string UserConversation(int UserID, int TabID, int DestinationID, string Text, DateTime now)
        {
            try
            {
                // Get a typed table to run queries
                Table<UserConversationInfo> UserTabsConnectInfos = db.GetTable<UserConversationInfo>();
                UserConversationInfo newUserConversation = new UserConversationInfo(UserID, TabID, DestinationID, now, Text);

                UserTabsConnectInfos.InsertOnSubmit(newUserConversation);
                db.SubmitChanges();
                return String.Empty;
            }
            catch (Exception ex)
            {
                return ex.Message;
            }
        }

        #endregion

    }

}
